t / test-lib.shon commit Merge branch 'rs/bash-is-in-coreutils-on-nonstop' (f26493b)
   1# Test framework for git.  See t/README for usage.
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# This program is free software: you can redistribute it and/or modify
   6# it under the terms of the GNU General Public License as published by
   7# the Free Software Foundation, either version 2 of the License, or
   8# (at your option) any later version.
   9#
  10# This program is distributed in the hope that it will be useful,
  11# but WITHOUT ANY WARRANTY; without even the implied warranty of
  12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  13# GNU General Public License for more details.
  14#
  15# You should have received a copy of the GNU General Public License
  16# along with this program.  If not, see http://www.gnu.org/licenses/ .
  17
  18# Test the binaries we have just built.  The tests are kept in
  19# t/ subdirectory and are run in 'trash directory' subdirectory.
  20if test -z "$TEST_DIRECTORY"
  21then
  22        # We allow tests to override this, in case they want to run tests
  23        # outside of t/, e.g. for running tests on the test library
  24        # itself.
  25        TEST_DIRECTORY=$(pwd)
  26else
  27        # ensure that TEST_DIRECTORY is an absolute path so that it
  28        # is valid even if the current working directory is changed
  29        TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
  30fi
  31if test -z "$TEST_OUTPUT_DIRECTORY"
  32then
  33        # Similarly, override this to store the test-results subdir
  34        # elsewhere
  35        TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
  36fi
  37GIT_BUILD_DIR="$TEST_DIRECTORY"/..
  38
  39# If we were built with ASAN, it may complain about leaks
  40# of program-lifetime variables. Disable it by default to lower
  41# the noise level. This needs to happen at the start of the script,
  42# before we even do our "did we build git yet" check (since we don't
  43# want that one to complain to stderr).
  44: ${ASAN_OPTIONS=detect_leaks=0:abort_on_error=1}
  45export ASAN_OPTIONS
  46
  47# If LSAN is in effect we _do_ want leak checking, but we still
  48# want to abort so that we notice the problems.
  49: ${LSAN_OPTIONS=abort_on_error=1}
  50export LSAN_OPTIONS
  51
  52if test ! -f "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
  53then
  54        echo >&2 'error: GIT-BUILD-OPTIONS missing (has Git been built?).'
  55        exit 1
  56fi
  57. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
  58export PERL_PATH SHELL_PATH
  59
  60################################################################
  61# It appears that people try to run tests without building...
  62"${GIT_TEST_INSTALLED:-$GIT_BUILD_DIR}/git$X" >/dev/null
  63if test $? != 1
  64then
  65        if test -n "$GIT_TEST_INSTALLED"
  66        then
  67                echo >&2 "error: there is no working Git at '$GIT_TEST_INSTALLED'"
  68        else
  69                echo >&2 'error: you do not seem to have built git yet.'
  70        fi
  71        exit 1
  72fi
  73
  74# Parse options while taking care to leave $@ intact, so we will still
  75# have all the original command line options when executing the test
  76# script again for '--tee' and '--verbose-log' below.
  77store_arg_to=
  78prev_opt=
  79for opt
  80do
  81        if test -n "$store_arg_to"
  82        then
  83                eval $store_arg_to=\$opt
  84                store_arg_to=
  85                prev_opt=
  86                continue
  87        fi
  88
  89        case "$opt" in
  90        -d|--d|--de|--deb|--debu|--debug)
  91                debug=t ;;
  92        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
  93                immediate=t ;;
  94        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
  95                GIT_TEST_LONG=t; export GIT_TEST_LONG ;;
  96        -r)
  97                store_arg_to=run_list
  98                ;;
  99        --run=*)
 100                run_list=${opt#--*=} ;;
 101        -h|--h|--he|--hel|--help)
 102                help=t ;;
 103        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 104                verbose=t ;;
 105        --verbose-only=*)
 106                verbose_only=${opt#--*=}
 107                ;;
 108        -q|--q|--qu|--qui|--quie|--quiet)
 109                # Ignore --quiet under a TAP::Harness. Saying how many tests
 110                # passed without the ok/not ok details is always an error.
 111                test -z "$HARNESS_ACTIVE" && quiet=t ;;
 112        --with-dashes)
 113                with_dashes=t ;;
 114        --no-bin-wrappers)
 115                no_bin_wrappers=t ;;
 116        --no-color)
 117                color= ;;
 118        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 119                valgrind=memcheck
 120                tee=t
 121                ;;
 122        --valgrind=*)
 123                valgrind=${opt#--*=}
 124                tee=t
 125                ;;
 126        --valgrind-only=*)
 127                valgrind_only=${opt#--*=}
 128                tee=t
 129                ;;
 130        --tee)
 131                tee=t ;;
 132        --root=*)
 133                root=${opt#--*=} ;;
 134        --chain-lint)
 135                GIT_TEST_CHAIN_LINT=1 ;;
 136        --no-chain-lint)
 137                GIT_TEST_CHAIN_LINT=0 ;;
 138        -x)
 139                trace=t ;;
 140        -V|--verbose-log)
 141                verbose_log=t
 142                tee=t
 143                ;;
 144        --write-junit-xml)
 145                write_junit_xml=t
 146                ;;
 147        --stress)
 148                stress=t ;;
 149        --stress=*)
 150                stress=${opt#--*=}
 151                case "$stress" in
 152                *[!0-9]*|0*|"")
 153                        echo "error: --stress=<N> requires the number of jobs to run" >&2
 154                        exit 1
 155                        ;;
 156                *)      # Good.
 157                        ;;
 158                esac
 159                ;;
 160        --stress-limit=*)
 161                stress_limit=${opt#--*=}
 162                case "$stress_limit" in
 163                *[!0-9]*|0*|"")
 164                        echo "error: --stress-limit=<N> requires the number of repetitions" >&2
 165                        exit 1
 166                        ;;
 167                *)      # Good.
 168                        ;;
 169                esac
 170                ;;
 171        *)
 172                echo "error: unknown test option '$opt'" >&2; exit 1 ;;
 173        esac
 174
 175        prev_opt=$opt
 176done
 177if test -n "$store_arg_to"
 178then
 179        echo "error: $prev_opt requires an argument" >&2
 180        exit 1
 181fi
 182
 183if test -n "$valgrind_only"
 184then
 185        test -z "$valgrind" && valgrind=memcheck
 186        test -z "$verbose" && verbose_only="$valgrind_only"
 187elif test -n "$valgrind"
 188then
 189        test -z "$verbose_log" && verbose=t
 190fi
 191
 192if test -n "$stress"
 193then
 194        verbose=t
 195        trace=t
 196        immediate=t
 197fi
 198
 199TEST_STRESS_JOB_SFX="${GIT_TEST_STRESS_JOB_NR:+.stress-$GIT_TEST_STRESS_JOB_NR}"
 200TEST_NAME="$(basename "$0" .sh)"
 201TEST_RESULTS_DIR="$TEST_OUTPUT_DIRECTORY/test-results"
 202TEST_RESULTS_BASE="$TEST_RESULTS_DIR/$TEST_NAME$TEST_STRESS_JOB_SFX"
 203TRASH_DIRECTORY="trash directory.$TEST_NAME$TEST_STRESS_JOB_SFX"
 204test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
 205case "$TRASH_DIRECTORY" in
 206/*) ;; # absolute path is good
 207 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
 208esac
 209
 210# If --stress was passed, run this test repeatedly in several parallel loops.
 211if test "$GIT_TEST_STRESS_STARTED" = "done"
 212then
 213        : # Don't stress test again.
 214elif test -n "$stress"
 215then
 216        if test "$stress" != t
 217        then
 218                job_count=$stress
 219        elif test -n "$GIT_TEST_STRESS_LOAD"
 220        then
 221                job_count="$GIT_TEST_STRESS_LOAD"
 222        elif job_count=$(getconf _NPROCESSORS_ONLN 2>/dev/null) &&
 223             test -n "$job_count"
 224        then
 225                job_count=$((2 * $job_count))
 226        else
 227                job_count=8
 228        fi
 229
 230        mkdir -p "$TEST_RESULTS_DIR"
 231        stressfail="$TEST_RESULTS_BASE.stress-failed"
 232        rm -f "$stressfail"
 233
 234        stress_exit=0
 235        trap '
 236                kill $job_pids 2>/dev/null
 237                wait
 238                stress_exit=1
 239        ' TERM INT HUP
 240
 241        job_pids=
 242        job_nr=0
 243        while test $job_nr -lt "$job_count"
 244        do
 245                (
 246                        GIT_TEST_STRESS_STARTED=done
 247                        GIT_TEST_STRESS_JOB_NR=$job_nr
 248                        export GIT_TEST_STRESS_STARTED GIT_TEST_STRESS_JOB_NR
 249
 250                        trap '
 251                                kill $test_pid 2>/dev/null
 252                                wait
 253                                exit 1
 254                        ' TERM INT
 255
 256                        cnt=1
 257                        while ! test -e "$stressfail" &&
 258                              { test -z "$stress_limit" ||
 259                                test $cnt -le $stress_limit ; }
 260                        do
 261                                $TEST_SHELL_PATH "$0" "$@" >"$TEST_RESULTS_BASE.stress-$job_nr.out" 2>&1 &
 262                                test_pid=$!
 263
 264                                if wait $test_pid
 265                                then
 266                                        printf "OK   %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
 267                                else
 268                                        echo $GIT_TEST_STRESS_JOB_NR >>"$stressfail"
 269                                        printf "FAIL %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
 270                                fi
 271                                cnt=$(($cnt + 1))
 272                        done
 273                ) &
 274                job_pids="$job_pids $!"
 275                job_nr=$(($job_nr + 1))
 276        done
 277
 278        wait
 279
 280        if test -f "$stressfail"
 281        then
 282                stress_exit=1
 283                echo "Log(s) of failed test run(s):"
 284                for failed_job_nr in $(sort -n "$stressfail")
 285                do
 286                        echo "Contents of '$TEST_RESULTS_BASE.stress-$failed_job_nr.out':"
 287                        cat "$TEST_RESULTS_BASE.stress-$failed_job_nr.out"
 288                done
 289                rm -rf "$TRASH_DIRECTORY.stress-failed"
 290                # Move the last one.
 291                mv "$TRASH_DIRECTORY.stress-$failed_job_nr" "$TRASH_DIRECTORY.stress-failed"
 292        fi
 293
 294        exit $stress_exit
 295fi
 296
 297# if --tee was passed, write the output not only to the terminal, but
 298# additionally to the file test-results/$BASENAME.out, too.
 299if test "$GIT_TEST_TEE_STARTED" = "done"
 300then
 301        : # do not redirect again
 302elif test -n "$tee"
 303then
 304        mkdir -p "$TEST_RESULTS_DIR"
 305
 306        # Make this filename available to the sub-process in case it is using
 307        # --verbose-log.
 308        GIT_TEST_TEE_OUTPUT_FILE=$TEST_RESULTS_BASE.out
 309        export GIT_TEST_TEE_OUTPUT_FILE
 310
 311        # Truncate before calling "tee -a" to get rid of the results
 312        # from any previous runs.
 313        >"$GIT_TEST_TEE_OUTPUT_FILE"
 314
 315        (GIT_TEST_TEE_STARTED=done ${TEST_SHELL_PATH} "$0" "$@" 2>&1;
 316         echo $? >"$TEST_RESULTS_BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
 317        test "$(cat "$TEST_RESULTS_BASE.exit")" = 0
 318        exit
 319fi
 320
 321if test -n "$trace" && test -n "$test_untraceable"
 322then
 323        # '-x' tracing requested, but this test script can't be reliably
 324        # traced, unless it is run with a Bash version supporting
 325        # BASH_XTRACEFD (introduced in Bash v4.1).
 326        #
 327        # Perform this version check _after_ the test script was
 328        # potentially re-executed with $TEST_SHELL_PATH for '--tee' or
 329        # '--verbose-log', so the right shell is checked and the
 330        # warning is issued only once.
 331        if test -n "$BASH_VERSION" && eval '
 332             test ${BASH_VERSINFO[0]} -gt 4 || {
 333               test ${BASH_VERSINFO[0]} -eq 4 &&
 334               test ${BASH_VERSINFO[1]} -ge 1
 335             }
 336           '
 337        then
 338                : Executed by a Bash version supporting BASH_XTRACEFD.  Good.
 339        else
 340                echo >&2 "warning: ignoring -x; '$0' is untraceable without BASH_XTRACEFD"
 341                trace=
 342        fi
 343fi
 344if test -n "$trace" && test -z "$verbose_log"
 345then
 346        verbose=t
 347fi
 348
 349# For repeatability, reset the environment to known value.
 350# TERM is sanitized below, after saving color control sequences.
 351LANG=C
 352LC_ALL=C
 353PAGER=cat
 354TZ=UTC
 355export LANG LC_ALL PAGER TZ
 356EDITOR=:
 357
 358# GIT_TEST_GETTEXT_POISON should not influence git commands executed
 359# during initialization of test-lib and the test repo. Back it up,
 360# unset and then restore after initialization is finished.
 361if test -n "$GIT_TEST_GETTEXT_POISON"
 362then
 363        GIT_TEST_GETTEXT_POISON_ORIG=$GIT_TEST_GETTEXT_POISON
 364        unset GIT_TEST_GETTEXT_POISON
 365fi
 366
 367# A call to "unset" with no arguments causes at least Solaris 10
 368# /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
 369# deriving from the command substitution clustered with the other
 370# ones.
 371unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
 372        my @env = keys %ENV;
 373        my $ok = join("|", qw(
 374                TRACE
 375                DEBUG
 376                TEST
 377                .*_TEST
 378                PROVE
 379                VALGRIND
 380                UNZIP
 381                PERF_
 382                CURL_VERBOSE
 383                TRACE_CURL
 384        ));
 385        my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
 386        print join("\n", @vars);
 387')
 388unset XDG_CACHE_HOME
 389unset XDG_CONFIG_HOME
 390unset GITPERLLIB
 391GIT_AUTHOR_EMAIL=author@example.com
 392GIT_AUTHOR_NAME='A U Thor'
 393GIT_COMMITTER_EMAIL=committer@example.com
 394GIT_COMMITTER_NAME='C O Mitter'
 395GIT_MERGE_VERBOSITY=5
 396GIT_MERGE_AUTOEDIT=no
 397export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
 398export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
 399export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
 400export EDITOR
 401
 402# Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
 403GIT_TRACE_BARE=1
 404export GIT_TRACE_BARE
 405
 406check_var_migration () {
 407        # the warnings and hints given from this helper depends
 408        # on end-user settings, which will disrupt the self-test
 409        # done on the test framework itself.
 410        case "$GIT_TEST_FRAMEWORK_SELFTEST" in
 411        t)      return ;;
 412        esac
 413
 414        old_name=$1 new_name=$2
 415        eval "old_isset=\${${old_name}:+isset}"
 416        eval "new_isset=\${${new_name}:+isset}"
 417
 418        case "$old_isset,$new_isset" in
 419        isset,)
 420                echo >&2 "warning: $old_name is now $new_name"
 421                echo >&2 "hint: set $new_name too during the transition period"
 422                eval "$new_name=\$$old_name"
 423                ;;
 424        isset,isset)
 425                # do this later
 426                # echo >&2 "warning: $old_name is now $new_name"
 427                # echo >&2 "hint: remove $old_name"
 428                ;;
 429        esac
 430}
 431
 432check_var_migration GIT_FSMONITOR_TEST GIT_TEST_FSMONITOR
 433check_var_migration TEST_GIT_INDEX_VERSION GIT_TEST_INDEX_VERSION
 434check_var_migration GIT_FORCE_PRELOAD_TEST GIT_TEST_PRELOAD_INDEX
 435
 436# Use specific version of the index file format
 437if test -n "${GIT_TEST_INDEX_VERSION:+isset}"
 438then
 439        GIT_INDEX_VERSION="$GIT_TEST_INDEX_VERSION"
 440        export GIT_INDEX_VERSION
 441fi
 442
 443# Add libc MALLOC and MALLOC_PERTURB test
 444# only if we are not executing the test with valgrind
 445if test -n "$valgrind" ||
 446   test -n "$TEST_NO_MALLOC_CHECK"
 447then
 448        setup_malloc_check () {
 449                : nothing
 450        }
 451        teardown_malloc_check () {
 452                : nothing
 453        }
 454else
 455        setup_malloc_check () {
 456                MALLOC_CHECK_=3 MALLOC_PERTURB_=165
 457                export MALLOC_CHECK_ MALLOC_PERTURB_
 458        }
 459        teardown_malloc_check () {
 460                unset MALLOC_CHECK_ MALLOC_PERTURB_
 461        }
 462fi
 463
 464# Protect ourselves from common misconfiguration to export
 465# CDPATH into the environment
 466unset CDPATH
 467
 468unset GREP_OPTIONS
 469unset UNZIP
 470
 471case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
 4721|2|true)
 473        GIT_TRACE=4
 474        ;;
 475esac
 476
 477# Convenience
 478#
 479# A regexp to match 5, 35 and 40 hexdigits
 480_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
 481_x35="$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
 482_x40="$_x35$_x05"
 483
 484# Zero SHA-1
 485_z40=0000000000000000000000000000000000000000
 486
 487OID_REGEX="$_x40"
 488ZERO_OID=$_z40
 489EMPTY_TREE=4b825dc642cb6eb9a060e54bf8d69288fbee4904
 490EMPTY_BLOB=e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
 491
 492# Line feed
 493LF='
 494'
 495
 496# UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
 497# when case-folding filenames
 498u200c=$(printf '\342\200\214')
 499
 500export _x05 _x35 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB ZERO_OID OID_REGEX
 501
 502# Each test should start with something like this, after copyright notices:
 503#
 504# test_description='Description of this test...
 505# This test checks if command xyzzy does the right thing...
 506# '
 507# . ./test-lib.sh
 508test "x$TERM" != "xdumb" && (
 509                test -t 1 &&
 510                tput bold >/dev/null 2>&1 &&
 511                tput setaf 1 >/dev/null 2>&1 &&
 512                tput sgr0 >/dev/null 2>&1
 513        ) &&
 514        color=t
 515
 516if test -n "$color"
 517then
 518        # Save the color control sequences now rather than run tput
 519        # each time say_color() is called.  This is done for two
 520        # reasons:
 521        #   * TERM will be changed to dumb
 522        #   * HOME will be changed to a temporary directory and tput
 523        #     might need to read ~/.terminfo from the original HOME
 524        #     directory to get the control sequences
 525        # Note:  This approach assumes the control sequences don't end
 526        # in a newline for any terminal of interest (command
 527        # substitutions strip trailing newlines).  Given that most
 528        # (all?) terminals in common use are related to ECMA-48, this
 529        # shouldn't be a problem.
 530        say_color_error=$(tput bold; tput setaf 1) # bold red
 531        say_color_skip=$(tput setaf 4) # blue
 532        say_color_warn=$(tput setaf 3) # brown/yellow
 533        say_color_pass=$(tput setaf 2) # green
 534        say_color_info=$(tput setaf 6) # cyan
 535        say_color_reset=$(tput sgr0)
 536        say_color_="" # no formatting for normal text
 537        say_color () {
 538                test -z "$1" && test -n "$quiet" && return
 539                eval "say_color_color=\$say_color_$1"
 540                shift
 541                printf "%s\\n" "$say_color_color$*$say_color_reset"
 542        }
 543else
 544        say_color() {
 545                test -z "$1" && test -n "$quiet" && return
 546                shift
 547                printf "%s\n" "$*"
 548        }
 549fi
 550
 551TERM=dumb
 552export TERM
 553
 554error () {
 555        say_color error "error: $*"
 556        GIT_EXIT_OK=t
 557        exit 1
 558}
 559
 560BUG () {
 561        error >&7 "bug in the test script: $*"
 562}
 563
 564say () {
 565        say_color info "$*"
 566}
 567
 568if test -n "$HARNESS_ACTIVE"
 569then
 570        if test "$verbose" = t || test -n "$verbose_only"
 571        then
 572                printf 'Bail out! %s\n' \
 573                 'verbose mode forbidden under TAP harness; try --verbose-log'
 574                exit 1
 575        fi
 576fi
 577
 578test "${test_description}" != "" ||
 579error "Test script did not set test_description."
 580
 581if test "$help" = "t"
 582then
 583        printf '%s\n' "$test_description"
 584        exit 0
 585fi
 586
 587exec 5>&1
 588exec 6<&0
 589exec 7>&2
 590if test "$verbose_log" = "t"
 591then
 592        exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
 593elif test "$verbose" = "t"
 594then
 595        exec 4>&2 3>&1
 596else
 597        exec 4>/dev/null 3>/dev/null
 598fi
 599
 600# Send any "-x" output directly to stderr to avoid polluting tests
 601# which capture stderr. We can do this unconditionally since it
 602# has no effect if tracing isn't turned on.
 603#
 604# Note that this sets up the trace fd as soon as we assign the variable, so it
 605# must come after the creation of descriptor 4 above. Likewise, we must never
 606# unset this, as it has the side effect of closing descriptor 4, which we
 607# use to show verbose tests to the user.
 608#
 609# Note also that we don't need or want to export it. The tracing is local to
 610# this shell, and we would not want to influence any shells we exec.
 611BASH_XTRACEFD=4
 612
 613test_failure=0
 614test_count=0
 615test_fixed=0
 616test_broken=0
 617test_success=0
 618
 619test_external_has_tap=0
 620
 621die () {
 622        code=$?
 623        if test -n "$GIT_EXIT_OK"
 624        then
 625                exit $code
 626        else
 627                echo >&5 "FATAL: Unexpected exit with code $code"
 628                exit 1
 629        fi
 630}
 631
 632GIT_EXIT_OK=
 633trap 'die' EXIT
 634trap 'exit $?' INT TERM HUP
 635
 636# The user-facing functions are loaded from a separate file so that
 637# test_perf subshells can have them too
 638. "$TEST_DIRECTORY/test-lib-functions.sh"
 639
 640# You are not expected to call test_ok_ and test_failure_ directly, use
 641# the test_expect_* functions instead.
 642
 643test_ok_ () {
 644        if test -n "$write_junit_xml"
 645        then
 646                write_junit_xml_testcase "$*"
 647        fi
 648        test_success=$(($test_success + 1))
 649        say_color "" "ok $test_count - $@"
 650}
 651
 652test_failure_ () {
 653        if test -n "$write_junit_xml"
 654        then
 655                junit_insert="<failure message=\"not ok $test_count -"
 656                junit_insert="$junit_insert $(xml_attr_encode "$1")\">"
 657                junit_insert="$junit_insert $(xml_attr_encode \
 658                        "$(if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
 659                           then
 660                                test-tool path-utils skip-n-bytes \
 661                                        "$GIT_TEST_TEE_OUTPUT_FILE" $GIT_TEST_TEE_OFFSET
 662                           else
 663                                printf '%s\n' "$@" | sed 1d
 664                           fi)")"
 665                junit_insert="$junit_insert</failure>"
 666                if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
 667                then
 668                        junit_insert="$junit_insert<system-err>$(xml_attr_encode \
 669                                "$(cat "$GIT_TEST_TEE_OUTPUT_FILE")")</system-err>"
 670                fi
 671                write_junit_xml_testcase "$1" "      $junit_insert"
 672        fi
 673        test_failure=$(($test_failure + 1))
 674        say_color error "not ok $test_count - $1"
 675        shift
 676        printf '%s\n' "$*" | sed -e 's/^/#      /'
 677        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 678}
 679
 680test_known_broken_ok_ () {
 681        if test -n "$write_junit_xml"
 682        then
 683                write_junit_xml_testcase "$* (breakage fixed)"
 684        fi
 685        test_fixed=$(($test_fixed+1))
 686        say_color error "ok $test_count - $@ # TODO known breakage vanished"
 687}
 688
 689test_known_broken_failure_ () {
 690        if test -n "$write_junit_xml"
 691        then
 692                write_junit_xml_testcase "$* (known breakage)"
 693        fi
 694        test_broken=$(($test_broken+1))
 695        say_color warn "not ok $test_count - $@ # TODO known breakage"
 696}
 697
 698test_debug () {
 699        test "$debug" = "" || eval "$1"
 700}
 701
 702match_pattern_list () {
 703        arg="$1"
 704        shift
 705        test -z "$*" && return 1
 706        for pattern_
 707        do
 708                case "$arg" in
 709                $pattern_)
 710                        return 0
 711                esac
 712        done
 713        return 1
 714}
 715
 716match_test_selector_list () {
 717        title="$1"
 718        shift
 719        arg="$1"
 720        shift
 721        test -z "$1" && return 0
 722
 723        # Both commas and whitespace are accepted as separators.
 724        OLDIFS=$IFS
 725        IFS='   ,'
 726        set -- $1
 727        IFS=$OLDIFS
 728
 729        # If the first selector is negative we include by default.
 730        include=
 731        case "$1" in
 732                !*) include=t ;;
 733        esac
 734
 735        for selector
 736        do
 737                orig_selector=$selector
 738
 739                positive=t
 740                case "$selector" in
 741                        !*)
 742                                positive=
 743                                selector=${selector##?}
 744                                ;;
 745                esac
 746
 747                test -z "$selector" && continue
 748
 749                case "$selector" in
 750                        *-*)
 751                                if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
 752                                then
 753                                        echo "error: $title: invalid non-numeric in range" \
 754                                                "start: '$orig_selector'" >&2
 755                                        exit 1
 756                                fi
 757                                if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
 758                                then
 759                                        echo "error: $title: invalid non-numeric in range" \
 760                                                "end: '$orig_selector'" >&2
 761                                        exit 1
 762                                fi
 763                                ;;
 764                        *)
 765                                if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
 766                                then
 767                                        echo "error: $title: invalid non-numeric in test" \
 768                                                "selector: '$orig_selector'" >&2
 769                                        exit 1
 770                                fi
 771                esac
 772
 773                # Short cut for "obvious" cases
 774                test -z "$include" && test -z "$positive" && continue
 775                test -n "$include" && test -n "$positive" && continue
 776
 777                case "$selector" in
 778                        -*)
 779                                if test $arg -le ${selector#-}
 780                                then
 781                                        include=$positive
 782                                fi
 783                                ;;
 784                        *-)
 785                                if test $arg -ge ${selector%-}
 786                                then
 787                                        include=$positive
 788                                fi
 789                                ;;
 790                        *-*)
 791                                if test ${selector%%-*} -le $arg \
 792                                        && test $arg -le ${selector#*-}
 793                                then
 794                                        include=$positive
 795                                fi
 796                                ;;
 797                        *)
 798                                if test $arg -eq $selector
 799                                then
 800                                        include=$positive
 801                                fi
 802                                ;;
 803                esac
 804        done
 805
 806        test -n "$include"
 807}
 808
 809maybe_teardown_verbose () {
 810        test -z "$verbose_only" && return
 811        exec 4>/dev/null 3>/dev/null
 812        verbose=
 813}
 814
 815last_verbose=t
 816maybe_setup_verbose () {
 817        test -z "$verbose_only" && return
 818        if match_pattern_list $test_count $verbose_only
 819        then
 820                exec 4>&2 3>&1
 821                # Emit a delimiting blank line when going from
 822                # non-verbose to verbose.  Within verbose mode the
 823                # delimiter is printed by test_expect_*.  The choice
 824                # of the initial $last_verbose is such that before
 825                # test 1, we do not print it.
 826                test -z "$last_verbose" && echo >&3 ""
 827                verbose=t
 828        else
 829                exec 4>/dev/null 3>/dev/null
 830                verbose=
 831        fi
 832        last_verbose=$verbose
 833}
 834
 835maybe_teardown_valgrind () {
 836        test -z "$GIT_VALGRIND" && return
 837        GIT_VALGRIND_ENABLED=
 838}
 839
 840maybe_setup_valgrind () {
 841        test -z "$GIT_VALGRIND" && return
 842        if test -z "$valgrind_only"
 843        then
 844                GIT_VALGRIND_ENABLED=t
 845                return
 846        fi
 847        GIT_VALGRIND_ENABLED=
 848        if match_pattern_list $test_count $valgrind_only
 849        then
 850                GIT_VALGRIND_ENABLED=t
 851        fi
 852}
 853
 854want_trace () {
 855        test "$trace" = t && {
 856                test "$verbose" = t || test "$verbose_log" = t
 857        }
 858}
 859
 860# This is a separate function because some tests use
 861# "return" to end a test_expect_success block early
 862# (and we want to make sure we run any cleanup like
 863# "set +x").
 864test_eval_inner_ () {
 865        # Do not add anything extra (including LF) after '$*'
 866        eval "
 867                want_trace && set -x
 868                $*"
 869}
 870
 871test_eval_ () {
 872        # If "-x" tracing is in effect, then we want to avoid polluting stderr
 873        # with non-test commands. But once in "set -x" mode, we cannot prevent
 874        # the shell from printing the "set +x" to turn it off (nor the saving
 875        # of $? before that). But we can make sure that the output goes to
 876        # /dev/null.
 877        #
 878        # There are a few subtleties here:
 879        #
 880        #   - we have to redirect descriptor 4 in addition to 2, to cover
 881        #     BASH_XTRACEFD
 882        #
 883        #   - the actual eval has to come before the redirection block (since
 884        #     it needs to see descriptor 4 to set up its stderr)
 885        #
 886        #   - likewise, any error message we print must be outside the block to
 887        #     access descriptor 4
 888        #
 889        #   - checking $? has to come immediately after the eval, but it must
 890        #     be _inside_ the block to avoid polluting the "set -x" output
 891        #
 892
 893        test_eval_inner_ "$@" </dev/null >&3 2>&4
 894        {
 895                test_eval_ret_=$?
 896                if want_trace
 897                then
 898                        set +x
 899                fi
 900        } 2>/dev/null 4>&2
 901
 902        if test "$test_eval_ret_" != 0 && want_trace
 903        then
 904                say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
 905        fi
 906        return $test_eval_ret_
 907}
 908
 909test_run_ () {
 910        test_cleanup=:
 911        expecting_failure=$2
 912
 913        if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
 914                # turn off tracing for this test-eval, as it simply creates
 915                # confusing noise in the "-x" output
 916                trace_tmp=$trace
 917                trace=
 918                # 117 is magic because it is unlikely to match the exit
 919                # code of other programs
 920                if $(printf '%s\n' "$1" | sed -f "$GIT_BUILD_DIR/t/chainlint.sed" | grep -q '?![A-Z][A-Z]*?!') ||
 921                        test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)"
 922                then
 923                        BUG "broken &&-chain or run-away HERE-DOC: $1"
 924                fi
 925                trace=$trace_tmp
 926        fi
 927
 928        setup_malloc_check
 929        test_eval_ "$1"
 930        eval_ret=$?
 931        teardown_malloc_check
 932
 933        if test -z "$immediate" || test $eval_ret = 0 ||
 934           test -n "$expecting_failure" && test "$test_cleanup" != ":"
 935        then
 936                setup_malloc_check
 937                test_eval_ "$test_cleanup"
 938                teardown_malloc_check
 939        fi
 940        if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
 941        then
 942                echo ""
 943        fi
 944        return "$eval_ret"
 945}
 946
 947test_start_ () {
 948        test_count=$(($test_count+1))
 949        maybe_setup_verbose
 950        maybe_setup_valgrind
 951        if test -n "$write_junit_xml"
 952        then
 953                junit_start=$(test-tool date getnanos)
 954        fi
 955}
 956
 957test_finish_ () {
 958        echo >&3 ""
 959        maybe_teardown_valgrind
 960        maybe_teardown_verbose
 961        if test -n "$GIT_TEST_TEE_OFFSET"
 962        then
 963                GIT_TEST_TEE_OFFSET=$(test-tool path-utils file-size \
 964                        "$GIT_TEST_TEE_OUTPUT_FILE")
 965        fi
 966}
 967
 968test_skip () {
 969        to_skip=
 970        skipped_reason=
 971        if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
 972        then
 973                to_skip=t
 974                skipped_reason="GIT_SKIP_TESTS"
 975        fi
 976        if test -z "$to_skip" && test -n "$test_prereq" &&
 977           ! test_have_prereq "$test_prereq"
 978        then
 979                to_skip=t
 980
 981                of_prereq=
 982                if test "$missing_prereq" != "$test_prereq"
 983                then
 984                        of_prereq=" of $test_prereq"
 985                fi
 986                skipped_reason="missing $missing_prereq${of_prereq}"
 987        fi
 988        if test -z "$to_skip" && test -n "$run_list" &&
 989                ! match_test_selector_list '--run' $test_count "$run_list"
 990        then
 991                to_skip=t
 992                skipped_reason="--run"
 993        fi
 994
 995        case "$to_skip" in
 996        t)
 997                if test -n "$write_junit_xml"
 998                then
 999                        message="$(xml_attr_encode "$skipped_reason")"
1000                        write_junit_xml_testcase "$1" \
1001                                "      <skipped message=\"$message\" />"
1002                fi
1003
1004                say_color skip >&3 "skipping test: $@"
1005                say_color skip "ok $test_count # skip $1 ($skipped_reason)"
1006                : true
1007                ;;
1008        *)
1009                false
1010                ;;
1011        esac
1012}
1013
1014# stub; perf-lib overrides it
1015test_at_end_hook_ () {
1016        :
1017}
1018
1019write_junit_xml () {
1020        case "$1" in
1021        --truncate)
1022                >"$junit_xml_path"
1023                junit_have_testcase=
1024                shift
1025                ;;
1026        esac
1027        printf '%s\n' "$@" >>"$junit_xml_path"
1028}
1029
1030xml_attr_encode () {
1031        printf '%s\n' "$@" | test-tool xml-encode
1032}
1033
1034write_junit_xml_testcase () {
1035        junit_attrs="name=\"$(xml_attr_encode "$this_test.$test_count $1")\""
1036        shift
1037        junit_attrs="$junit_attrs classname=\"$this_test\""
1038        junit_attrs="$junit_attrs time=\"$(test-tool \
1039                date getnanos $junit_start)\""
1040        write_junit_xml "$(printf '%s\n' \
1041                "    <testcase $junit_attrs>" "$@" "    </testcase>")"
1042        junit_have_testcase=t
1043}
1044
1045test_done () {
1046        GIT_EXIT_OK=t
1047
1048        if test -n "$write_junit_xml" && test -n "$junit_xml_path"
1049        then
1050                test -n "$junit_have_testcase" || {
1051                        junit_start=$(test-tool date getnanos)
1052                        write_junit_xml_testcase "all tests skipped"
1053                }
1054
1055                # adjust the overall time
1056                junit_time=$(test-tool date getnanos $junit_suite_start)
1057                sed "s/<testsuite [^>]*/& time=\"$junit_time\"/" \
1058                        <"$junit_xml_path" >"$junit_xml_path.new"
1059                mv "$junit_xml_path.new" "$junit_xml_path"
1060
1061                write_junit_xml "  </testsuite>" "</testsuites>"
1062        fi
1063
1064        if test -z "$HARNESS_ACTIVE"
1065        then
1066                mkdir -p "$TEST_RESULTS_DIR"
1067
1068                cat >"$TEST_RESULTS_BASE.counts" <<-EOF
1069                total $test_count
1070                success $test_success
1071                fixed $test_fixed
1072                broken $test_broken
1073                failed $test_failure
1074
1075                EOF
1076        fi
1077
1078        if test "$test_fixed" != 0
1079        then
1080                say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
1081        fi
1082        if test "$test_broken" != 0
1083        then
1084                say_color warn "# still have $test_broken known breakage(s)"
1085        fi
1086        if test "$test_broken" != 0 || test "$test_fixed" != 0
1087        then
1088                test_remaining=$(( $test_count - $test_broken - $test_fixed ))
1089                msg="remaining $test_remaining test(s)"
1090        else
1091                test_remaining=$test_count
1092                msg="$test_count test(s)"
1093        fi
1094        case "$test_failure" in
1095        0)
1096                if test $test_external_has_tap -eq 0
1097                then
1098                        if test $test_remaining -gt 0
1099                        then
1100                                say_color pass "# passed all $msg"
1101                        fi
1102
1103                        # Maybe print SKIP message
1104                        test -z "$skip_all" || skip_all="# SKIP $skip_all"
1105                        case "$test_count" in
1106                        0)
1107                                say "1..$test_count${skip_all:+ $skip_all}"
1108                                ;;
1109                        *)
1110                                test -z "$skip_all" ||
1111                                say_color warn "$skip_all"
1112                                say "1..$test_count"
1113                                ;;
1114                        esac
1115                fi
1116
1117                if test -z "$debug"
1118                then
1119                        test -d "$TRASH_DIRECTORY" ||
1120                        error "Tests passed but trash directory already removed before test cleanup; aborting"
1121
1122                        cd "$TRASH_DIRECTORY/.." &&
1123                        rm -fr "$TRASH_DIRECTORY" || {
1124                                # try again in a bit
1125                                sleep 5;
1126                                rm -fr "$TRASH_DIRECTORY"
1127                        } ||
1128                        error "Tests passed but test cleanup failed; aborting"
1129                fi
1130                test_at_end_hook_
1131
1132                exit 0 ;;
1133
1134        *)
1135                if test $test_external_has_tap -eq 0
1136                then
1137                        say_color error "# failed $test_failure among $msg"
1138                        say "1..$test_count"
1139                fi
1140
1141                exit 1 ;;
1142
1143        esac
1144}
1145
1146if test -n "$valgrind"
1147then
1148        make_symlink () {
1149                test -h "$2" &&
1150                test "$1" = "$(readlink "$2")" || {
1151                        # be super paranoid
1152                        if mkdir "$2".lock
1153                        then
1154                                rm -f "$2" &&
1155                                ln -s "$1" "$2" &&
1156                                rm -r "$2".lock
1157                        else
1158                                while test -d "$2".lock
1159                                do
1160                                        say "Waiting for lock on $2."
1161                                        sleep 1
1162                                done
1163                        fi
1164                }
1165        }
1166
1167        make_valgrind_symlink () {
1168                # handle only executables, unless they are shell libraries that
1169                # need to be in the exec-path.
1170                test -x "$1" ||
1171                test "# " = "$(test_copy_bytes 2 <"$1")" ||
1172                return;
1173
1174                base=$(basename "$1")
1175                case "$base" in
1176                test-*)
1177                        symlink_target="$GIT_BUILD_DIR/t/helper/$base"
1178                        ;;
1179                *)
1180                        symlink_target="$GIT_BUILD_DIR/$base"
1181                        ;;
1182                esac
1183                # do not override scripts
1184                if test -x "$symlink_target" &&
1185                    test ! -d "$symlink_target" &&
1186                    test "#!" != "$(test_copy_bytes 2 <"$symlink_target")"
1187                then
1188                        symlink_target=../valgrind.sh
1189                fi
1190                case "$base" in
1191                *.sh|*.perl)
1192                        symlink_target=../unprocessed-script
1193                esac
1194                # create the link, or replace it if it is out of date
1195                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
1196        }
1197
1198        # override all git executables in TEST_DIRECTORY/..
1199        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
1200        mkdir -p "$GIT_VALGRIND"/bin
1201        for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
1202        do
1203                make_valgrind_symlink $file
1204        done
1205        # special-case the mergetools loadables
1206        make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
1207        OLDIFS=$IFS
1208        IFS=:
1209        for path in $PATH
1210        do
1211                ls "$path"/git-* 2> /dev/null |
1212                while read file
1213                do
1214                        make_valgrind_symlink "$file"
1215                done
1216        done
1217        IFS=$OLDIFS
1218        PATH=$GIT_VALGRIND/bin:$PATH
1219        GIT_EXEC_PATH=$GIT_VALGRIND/bin
1220        export GIT_VALGRIND
1221        GIT_VALGRIND_MODE="$valgrind"
1222        export GIT_VALGRIND_MODE
1223        GIT_VALGRIND_ENABLED=t
1224        test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
1225        export GIT_VALGRIND_ENABLED
1226elif test -n "$GIT_TEST_INSTALLED"
1227then
1228        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
1229        error "Cannot run git from $GIT_TEST_INSTALLED."
1230        PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR/t/helper:$PATH
1231        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
1232else # normal case, use ../bin-wrappers only unless $with_dashes:
1233        if test -n "$no_bin_wrappers"
1234        then
1235                with_dashes=t
1236        else
1237                git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1238                if ! test -x "$git_bin_dir/git"
1239                then
1240                        if test -z "$with_dashes"
1241                        then
1242                                say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
1243                        fi
1244                        with_dashes=t
1245                fi
1246                PATH="$git_bin_dir:$PATH"
1247        fi
1248        GIT_EXEC_PATH=$GIT_BUILD_DIR
1249        if test -n "$with_dashes"
1250        then
1251                PATH="$GIT_BUILD_DIR:$GIT_BUILD_DIR/t/helper:$PATH"
1252        fi
1253fi
1254GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
1255GIT_CONFIG_NOSYSTEM=1
1256GIT_ATTR_NOSYSTEM=1
1257export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
1258
1259if test -z "$GIT_TEST_CMP"
1260then
1261        if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1262        then
1263                GIT_TEST_CMP="$DIFF -c"
1264        else
1265                GIT_TEST_CMP="$DIFF -u"
1266        fi
1267fi
1268
1269GITPERLLIB="$GIT_BUILD_DIR"/perl/build/lib
1270export GITPERLLIB
1271test -d "$GIT_BUILD_DIR"/templates/blt || {
1272        error "You haven't built things yet, have you?"
1273}
1274
1275if ! test -x "$GIT_BUILD_DIR"/t/helper/test-tool$X
1276then
1277        echo >&2 'You need to build test-tool:'
1278        echo >&2 'Run "make t/helper/test-tool" in the source (toplevel) directory'
1279        exit 1
1280fi
1281
1282# Test repository
1283rm -fr "$TRASH_DIRECTORY" || {
1284        GIT_EXIT_OK=t
1285        echo >&5 "FATAL: Cannot prepare test area"
1286        exit 1
1287}
1288
1289HOME="$TRASH_DIRECTORY"
1290GNUPGHOME="$HOME/gnupg-home-not-used"
1291export HOME GNUPGHOME
1292
1293if test -z "$TEST_NO_CREATE_REPO"
1294then
1295        test_create_repo "$TRASH_DIRECTORY"
1296else
1297        mkdir -p "$TRASH_DIRECTORY"
1298fi
1299
1300# Use -P to resolve symlinks in our working directory so that the cwd
1301# in subprocesses like git equals our $PWD (for pathname comparisons).
1302cd -P "$TRASH_DIRECTORY" || exit 1
1303
1304this_test=${0##*/}
1305this_test=${this_test%%-*}
1306if match_pattern_list "$this_test" $GIT_SKIP_TESTS
1307then
1308        say_color info >&3 "skipping test $this_test altogether"
1309        skip_all="skip all tests in $this_test"
1310        test_done
1311fi
1312
1313if test -n "$write_junit_xml"
1314then
1315        junit_xml_dir="$TEST_OUTPUT_DIRECTORY/out"
1316        mkdir -p "$junit_xml_dir"
1317        junit_xml_base=${0##*/}
1318        junit_xml_path="$junit_xml_dir/TEST-${junit_xml_base%.sh}.xml"
1319        junit_attrs="name=\"${junit_xml_base%.sh}\""
1320        junit_attrs="$junit_attrs timestamp=\"$(TZ=UTC \
1321                date +%Y-%m-%dT%H:%M:%S)\""
1322        write_junit_xml --truncate "<testsuites>" "  <testsuite $junit_attrs>"
1323        junit_suite_start=$(test-tool date getnanos)
1324        if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
1325        then
1326                GIT_TEST_TEE_OFFSET=0
1327        fi
1328fi
1329
1330# Provide an implementation of the 'yes' utility
1331yes () {
1332        if test $# = 0
1333        then
1334                y=y
1335        else
1336                y="$*"
1337        fi
1338
1339        i=0
1340        while test $i -lt 99
1341        do
1342                echo "$y"
1343                i=$(($i+1))
1344        done
1345}
1346
1347# Fix some commands on Windows
1348uname_s=$(uname -s)
1349case $uname_s in
1350*MINGW*)
1351        # Windows has its own (incompatible) sort and find
1352        sort () {
1353                /usr/bin/sort "$@"
1354        }
1355        find () {
1356                /usr/bin/find "$@"
1357        }
1358        # git sees Windows-style pwd
1359        pwd () {
1360                builtin pwd -W
1361        }
1362        # no POSIX permissions
1363        # backslashes in pathspec are converted to '/'
1364        # exec does not inherit the PID
1365        test_set_prereq MINGW
1366        test_set_prereq NATIVE_CRLF
1367        test_set_prereq SED_STRIPS_CR
1368        test_set_prereq GREP_STRIPS_CR
1369        GIT_TEST_CMP=mingw_test_cmp
1370        ;;
1371*CYGWIN*)
1372        test_set_prereq POSIXPERM
1373        test_set_prereq EXECKEEPSPID
1374        test_set_prereq CYGWIN
1375        test_set_prereq SED_STRIPS_CR
1376        test_set_prereq GREP_STRIPS_CR
1377        ;;
1378*)
1379        test_set_prereq POSIXPERM
1380        test_set_prereq BSLASHPSPEC
1381        test_set_prereq EXECKEEPSPID
1382        ;;
1383esac
1384
1385( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1386test -z "$NO_PERL" && test_set_prereq PERL
1387test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
1388test -z "$NO_PYTHON" && test_set_prereq PYTHON
1389test -n "$USE_LIBPCRE1$USE_LIBPCRE2" && test_set_prereq PCRE
1390test -n "$USE_LIBPCRE1" && test_set_prereq LIBPCRE1
1391test -n "$USE_LIBPCRE2" && test_set_prereq LIBPCRE2
1392test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1393
1394if test -n "$GIT_TEST_GETTEXT_POISON_ORIG"
1395then
1396        GIT_TEST_GETTEXT_POISON=$GIT_TEST_GETTEXT_POISON_ORIG
1397        unset GIT_TEST_GETTEXT_POISON_ORIG
1398fi
1399
1400# Can we rely on git's output in the C locale?
1401if test -z "$GIT_TEST_GETTEXT_POISON"
1402then
1403        test_set_prereq C_LOCALE_OUTPUT
1404fi
1405
1406if test -z "$GIT_TEST_CHECK_CACHE_TREE"
1407then
1408        GIT_TEST_CHECK_CACHE_TREE=true
1409        export GIT_TEST_CHECK_CACHE_TREE
1410fi
1411
1412test_lazy_prereq PIPE '
1413        # test whether the filesystem supports FIFOs
1414        test_have_prereq !MINGW,!CYGWIN &&
1415        rm -f testfifo && mkfifo testfifo
1416'
1417
1418test_lazy_prereq SYMLINKS '
1419        # test whether the filesystem supports symbolic links
1420        ln -s x y && test -h y
1421'
1422
1423test_lazy_prereq FILEMODE '
1424        test "$(git config --bool core.filemode)" = true
1425'
1426
1427test_lazy_prereq CASE_INSENSITIVE_FS '
1428        echo good >CamelCase &&
1429        echo bad >camelcase &&
1430        test "$(cat CamelCase)" != good
1431'
1432
1433test_lazy_prereq FUNNYNAMES '
1434        test_have_prereq !MINGW &&
1435        touch -- \
1436                "FUNNYNAMES tab embedded" \
1437                "FUNNYNAMES \"quote embedded\"" \
1438                "FUNNYNAMES newline
1439embedded" 2>/dev/null &&
1440        rm -- \
1441                "FUNNYNAMES tab embedded" \
1442                "FUNNYNAMES \"quote embedded\"" \
1443                "FUNNYNAMES newline
1444embedded" 2>/dev/null
1445'
1446
1447test_lazy_prereq UTF8_NFD_TO_NFC '
1448        # check whether FS converts nfd unicode to nfc
1449        auml=$(printf "\303\244")
1450        aumlcdiar=$(printf "\141\314\210")
1451        >"$auml" &&
1452        test -f "$aumlcdiar"
1453'
1454
1455test_lazy_prereq AUTOIDENT '
1456        sane_unset GIT_AUTHOR_NAME &&
1457        sane_unset GIT_AUTHOR_EMAIL &&
1458        git var GIT_AUTHOR_IDENT
1459'
1460
1461test_lazy_prereq EXPENSIVE '
1462        test -n "$GIT_TEST_LONG"
1463'
1464
1465test_lazy_prereq EXPENSIVE_ON_WINDOWS '
1466        test_have_prereq EXPENSIVE || test_have_prereq !MINGW,!CYGWIN
1467'
1468
1469test_lazy_prereq USR_BIN_TIME '
1470        test -x /usr/bin/time
1471'
1472
1473test_lazy_prereq NOT_ROOT '
1474        uid=$(id -u) &&
1475        test "$uid" != 0
1476'
1477
1478test_lazy_prereq JGIT '
1479        type jgit
1480'
1481
1482# SANITY is about "can you correctly predict what the filesystem would
1483# do by only looking at the permission bits of the files and
1484# directories?"  A typical example of !SANITY is running the test
1485# suite as root, where a test may expect "chmod -r file && cat file"
1486# to fail because file is supposed to be unreadable after a successful
1487# chmod.  In an environment (i.e. combination of what filesystem is
1488# being used and who is running the tests) that lacks SANITY, you may
1489# be able to delete or create a file when the containing directory
1490# doesn't have write permissions, or access a file even if the
1491# containing directory doesn't have read or execute permissions.
1492
1493test_lazy_prereq SANITY '
1494        mkdir SANETESTD.1 SANETESTD.2 &&
1495
1496        chmod +w SANETESTD.1 SANETESTD.2 &&
1497        >SANETESTD.1/x 2>SANETESTD.2/x &&
1498        chmod -w SANETESTD.1 &&
1499        chmod -r SANETESTD.1/x &&
1500        chmod -rx SANETESTD.2 ||
1501        BUG "cannot prepare SANETESTD"
1502
1503        ! test -r SANETESTD.1/x &&
1504        ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1505        status=$?
1506
1507        chmod +rwx SANETESTD.1 SANETESTD.2 &&
1508        rm -rf SANETESTD.1 SANETESTD.2 ||
1509        BUG "cannot clean SANETESTD"
1510        return $status
1511'
1512
1513test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
1514GIT_UNZIP=${GIT_UNZIP:-unzip}
1515test_lazy_prereq UNZIP '
1516        "$GIT_UNZIP" -v
1517        test $? -ne 127
1518'
1519
1520run_with_limited_cmdline () {
1521        (ulimit -s 128 && "$@")
1522}
1523
1524test_lazy_prereq CMDLINE_LIMIT '
1525        test_have_prereq !MINGW,!CYGWIN &&
1526        run_with_limited_cmdline true
1527'
1528
1529run_with_limited_stack () {
1530        (ulimit -s 128 && "$@")
1531}
1532
1533test_lazy_prereq ULIMIT_STACK_SIZE '
1534        test_have_prereq !MINGW,!CYGWIN &&
1535        run_with_limited_stack true
1536'
1537
1538build_option () {
1539        git version --build-options |
1540        sed -ne "s/^$1: //p"
1541}
1542
1543test_lazy_prereq LONG_IS_64BIT '
1544        test 8 -le "$(build_option sizeof-long)"
1545'
1546
1547test_lazy_prereq TIME_IS_64BIT 'test-tool date is64bit'
1548test_lazy_prereq TIME_T_IS_64BIT 'test-tool date time_t-is64bit'
1549
1550test_lazy_prereq CURL '
1551        curl --version
1552'
1553
1554# SHA1 is a test if the hash algorithm in use is SHA-1.  This is both for tests
1555# which will not work with other hash algorithms and tests that work but don't
1556# test anything meaningful (e.g. special values which cause short collisions).
1557test_lazy_prereq SHA1 '
1558        test $(git hash-object /dev/null) = e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
1559'
1560
1561test_lazy_prereq REBASE_P '
1562        test -z "$GIT_TEST_SKIP_REBASE_P"
1563'